diff --git a/src/main/java/net/minecraft/client/render/entity/PaintingRenderer.java b/src/main/java/net/minecraft/client/render/entity/PaintingRenderer.java
index cc305742a..c71b15909 100644
--- a/src/main/java/net/minecraft/client/render/entity/PaintingRenderer.java
+++ b/src/main/java/net/minecraft/client/render/entity/PaintingRenderer.java
@@ -1,11 +1,11 @@
 package net.minecraft.client.render.entity;
 
 import net.minecraft.client.render.LightmapHelper;
-import net.minecraft.client.render.stitcher.IconCoordinate;
-import net.minecraft.client.render.stitcher.TextureRegistry;
+import net.minecraft.client.render.texture.stitcher.IconCoordinate;
+import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.Global;
-import net.minecraft.core.entity.EntityPainting;
+import net.minecraft.core.entity.PaintingEntity;
 import net.minecraft.core.enums.ArtType;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.util.collection.NamespaceID;
@@ -15,7 +15,7 @@ import org.lwjgl.opengl.GL12;
 
 import java.util.Random;
 
-public class PaintingRenderer extends EntityRenderer<EntityPainting>
+public class PaintingRenderer extends EntityRenderer<PaintingEntity>
 {
     private static final IconCoordinate paintingBack = TextureRegistry.getTexture("minecraft:art/backing");
     public PaintingRenderer()
@@ -23,8 +23,8 @@ public class PaintingRenderer extends EntityRenderer<EntityPainting>
         rand = new Random();
     }
 
-    private void renderArt(Tessellator tessellator, EntityPainting entity, int sizeX, int sizeY, IconCoordinate iconCoordinate) {
-        iconCoordinate.parentAtlas.bindTexture();
+    private void renderArt(Tessellator tessellator, PaintingEntity entity, int sizeX, int sizeY, IconCoordinate iconCoordinate) {
+        iconCoordinate.parentAtlas.bind();
         float negCenterX = (float)(-sizeX) / 2.0F;
         float negCenterY = (float)(-sizeY) / 2.0F;
         float minZ = -0.5F;
@@ -104,26 +104,26 @@ public class PaintingRenderer extends EntityRenderer<EntityPainting>
 
     }
 
-    private void setupPaintingBrightness(EntityPainting entity, float centerX, float centerY)
+    private void setupPaintingBrightness(PaintingEntity entity, float centerX, float centerY)
     {
-        int worldX = MathHelper.floor_double(entity.x);
-        int worldY = MathHelper.floor_double(entity.y + (double)(centerY / 16F));
-        int worldZ = MathHelper.floor_double(entity.z);
+        int worldX = MathHelper.floor(entity.x);
+        int worldY = MathHelper.floor(entity.y + (double)(centerY / 16F));
+        int worldZ = MathHelper.floor(entity.z);
         if(entity.direction == 0)
         {
-            worldX = MathHelper.floor_double(entity.x + (double)(centerX / 16F));
+            worldX = MathHelper.floor(entity.x + (double)(centerX / 16F));
         }
         if(entity.direction == 1)
         {
-            worldZ = MathHelper.floor_double(entity.z - (double)(centerX / 16F));
+            worldZ = MathHelper.floor(entity.z - (double)(centerX / 16F));
         }
         if(entity.direction == 2)
         {
-            worldX = MathHelper.floor_double(entity.x - (double)(centerX / 16F));
+            worldX = MathHelper.floor(entity.x - (double)(centerX / 16F));
         }
         if(entity.direction == 3)
         {
-            worldZ = MathHelper.floor_double(entity.z + (double)(centerX / 16F));
+            worldZ = MathHelper.floor(entity.z + (double)(centerX / 16F));
         }
         float brightness = renderDispatcher.world.getLightBrightness(worldX, worldY, worldZ);
         if (Global.accessor.isFullbrightEnabled() || LightmapHelper.isLightmapEnabled()) {
@@ -134,7 +134,7 @@ public class PaintingRenderer extends EntityRenderer<EntityPainting>
     }
 
     @Override
-    public void doRender(Tessellator tessellator, EntityPainting entity, double x, double y, double z, float yaw, float partialTick) {
+    public void render(Tessellator tessellator, PaintingEntity entity, double x, double y, double z, float yaw, float partialTick) {
         rand.setSeed(187L);
         GL11.glPushMatrix();
         GL11.glTranslatef((float)x, (float)y, (float)z);
@@ -149,15 +149,15 @@ public class PaintingRenderer extends EntityRenderer<EntityPainting>
             GL11.glEnable(GL11.GL_BLEND);
             GL11.glBlendFunc(770, 771);
             GL11.glColor4f(1f, 1f, 1f, 1f);
-            NamespaceID id = EntityPainting.getBorder(borderStack);
-            loadTexture(String.format("/assets/%s/textures/art/borders/%s.png", id.namespace, id.value));
+            NamespaceID id = PaintingEntity.getBorder(borderStack);
+            bindTexture(String.format("/assets/%s/textures/art/borders/%s.png", id.namespace, id.value));
             renderBorder(entity, entity.art.sizeX, entity.art.sizeY);
             GL11.glDisable(GL11.GL_BLEND);
         }
         GL11.glDisable(GL12.GL_RESCALE_NORMAL);
         GL11.glPopMatrix();
     }
-    private void renderBorder(EntityPainting entity, int sizeX, int sizeY) {
+    private void renderBorder(PaintingEntity entity, int sizeX, int sizeY) {
         float negCenterX = (float)(-sizeX) / 2.0f;
         float negCenterY = (float)(-sizeY) / 2.0f;
         float minZ = -0.6f;
diff --git a/src/main/java/net/minecraft/client/render/entity/PigRenderer.java b/src/main/java/net/minecraft/client/render/entity/PigRenderer.java
index 1006165b7..ed42e66d3 100644
--- a/src/main/java/net/minecraft/client/render/entity/PigRenderer.java
+++ b/src/main/java/net/minecraft/client/render/entity/PigRenderer.java
@@ -2,28 +2,28 @@ package net.minecraft.client.render.entity;
 
 
 // Referenced classes of package net.minecraft.src:
-//            RenderLiving, EntityPig, ModelBase, EntityLiving
+//            RenderLiving, PigMob, BaseModel, Mob
 
-import net.minecraft.client.render.model.ModelBase;
-import net.minecraft.core.entity.animal.EntityPig;
+import net.minecraft.client.render.model.BaseModel;
+import net.minecraft.core.entity.animal.PigMob;
 
-public class PigRenderer extends LivingRenderer<EntityPig>
+public class PigRenderer extends MobRenderer<PigMob>
 {
 
-    public PigRenderer(ModelBase modelbase, ModelBase modelbase1, float f)
+    public PigRenderer(BaseModel modelbase, BaseModel modelbase1, float f)
     {
         super(modelbase, f);
-        setRenderPassModel(modelbase1);
+        setArmorModel(modelbase1);
     }
 
-    protected boolean renderSaddledPig(EntityPig entity, int i, float f)
+    protected boolean renderSaddledPig(PigMob entity, int i, float f)
     {
-        loadTexture("/assets/minecraft/textures/entity/saddle.png");
+        bindTexture("/assets/minecraft/textures/entity/saddle.png");
         return i == 0 && entity != null && entity.getSaddled();
     }
 
     @Override
-    protected boolean shouldRenderPass(EntityPig entity, int renderPass, float partialTick)
+    protected boolean prepareArmor(PigMob entity, int renderPass, float partialTick)
     {
         return renderSaddledPig(entity, renderPass, partialTick);
     }
diff --git a/src/main/java/net/minecraft/client/render/entity/PlayerRenderer.java b/src/main/java/net/minecraft/client/render/entity/PlayerRenderer.java
index 8f398c0fe..659b8a848 100644
--- a/src/main/java/net/minecraft/client/render/entity/PlayerRenderer.java
+++ b/src/main/java/net/minecraft/client/render/entity/PlayerRenderer.java
@@ -2,168 +2,42 @@ package net.minecraft.client.render.entity;
 
 import net.minecraft.client.Minecraft;
 
+import net.minecraft.client.entity.player.LocalPlayer;
 import net.minecraft.client.render.FontRenderer;
 import net.minecraft.client.render.PlayerSkinParser;
 import net.minecraft.client.render.block.model.BlockModel;
 import net.minecraft.client.render.block.model.BlockModelDispatcher;
 import net.minecraft.client.render.camera.EntityCamera;
 import net.minecraft.client.render.item.model.ItemModelDispatcher;
-import net.minecraft.client.render.model.ModelBiped;
-import net.minecraft.client.render.model.ModelPlayer;
-import net.minecraft.client.render.model.ModelPlayerSlim;
-import net.minecraft.client.render.model.ModelSign;
+import net.minecraft.client.render.model.BipedModel;
+import net.minecraft.client.render.model.PlayerModel;
+import net.minecraft.client.render.model.PlayerSlimModel;
 import net.minecraft.client.render.tessellator.Tessellator;
-import net.minecraft.core.entity.player.EntityPlayer;
-import net.minecraft.client.entity.player.EntityPlayerSP;
+import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.item.*;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.player.gamemode.Gamemode;
 import net.minecraft.core.util.helper.MathHelper;
 import org.lwjgl.opengl.GL11;
 
-// Referenced classes of package net.minecraft.src:
-//            RenderLiving, ModelBiped, EntityPlayer, InventoryPlayer, 
-//            ItemStack, ItemArmor, ModelRenderer, EntityPlayerSP, 
-//            RenderManager, Tessellator, FontRenderer, Item,
-//            Block, RenderBlocks, ItemRenderer, MathHelper, 
-//            EntityLiving, Entity
-
-public class PlayerRenderer extends LivingRenderer<EntityPlayer>
+public class PlayerRenderer extends MobRenderer<Player>
 {
+    private BipedModel modelBipedMain;
+    private final PlayerModel modelThick;
+    private final PlayerModel modelSlim;
+    private final BipedModel modelArmorChestplate;
+    private final BipedModel modelArmor;
 
     public PlayerRenderer()
     {
-        super(new ModelPlayer(0.0F), 0.5F);
-        modelBipedMain = (ModelBiped)mainModel;
-        modelArmorChestplate = new ModelBiped(1.0F);
-        modelArmor = new ModelBiped(0.5F);
-        modelSign = new ModelSign();
-        modelThick = new ModelPlayer(0.0f);
-        modelSlim = new ModelPlayerSlim(0.0f);
+        super(new PlayerModel(0.0F), 0.5F);
+        modelBipedMain = (BipedModel)mainModel;
+        modelArmorChestplate = new BipedModel(1.0F);
+        modelArmor = new BipedModel(0.5F);
+        modelThick = new PlayerModel(0.0f);
+        modelSlim = new PlayerSlimModel(0.0f);
     }
-
-    protected boolean setArmorModel(EntityPlayer entity, int renderPass, float partialTick)
-    {
-        ItemStack itemstack = entity.inventory.armorItemInSlot(3 - renderPass);
-        if(itemstack != null)
-        {
-            Item item = itemstack.getItem();
-            if(item instanceof ItemQuiver)
-            {
-                loadTexture("/assets/minecraft/textures/armor/quiver.png");
-                ModelBiped modelbiped = modelArmorChestplate;
-                modelbiped.bipedBody.showModel = renderPass == 1 || renderPass == 2;
-                setRenderPassModel(modelbiped);
-                return true;
-            }
-            if(item instanceof ItemQuiverEndless)
-            {
-                loadTexture("/assets/minecraft/textures/armor/quiver_golden.png");
-                ModelBiped modelbiped = modelArmorChestplate;
-                modelbiped.bipedBody.showModel = renderPass == 1 || renderPass == 2;
-                setRenderPassModel(modelbiped);
-                return true;
-            }
-            if(item == Item.armorBootsIceskates)
-            {
-                loadTexture("/assets/minecraft/textures/armor/skates.png");
-                ModelBiped modelbiped = modelArmorChestplate;
-                modelbiped.bipedRightLeg.showModel = renderPass == 2 || renderPass == 3;
-                modelbiped.bipedLeftLeg.showModel = renderPass == 2 || renderPass == 3;
-                setRenderPassModel(modelbiped);
-                return true;
-            }
-            if(item instanceof ItemArmor)
-            {
-                ItemArmor itemarmor = (ItemArmor)item;
-                loadTexture(String.format("/assets/%s/textures/armor/%s_%d.png", itemarmor.material.identifier.namespace, itemarmor.material.identifier.value, (renderPass != 2 ? 1 : 2)));
-                ModelBiped modelbiped = renderPass != 2 ? modelArmorChestplate : modelArmor;
-                modelbiped.bipedHead.showModel = renderPass == 0;
-                modelbiped.bipedHeadOverlay.showModel = renderPass == 0;
-                modelbiped.bipedBody.showModel = renderPass == 1 || renderPass == 2;
-                modelbiped.bipedRightArm.showModel = renderPass == 1;
-                modelbiped.bipedLeftArm.showModel = renderPass == 1;
-                modelbiped.bipedRightLeg.showModel = renderPass == 2 || renderPass == 3;
-                modelbiped.bipedLeftLeg.showModel = renderPass == 2 || renderPass == 3;
-                setRenderPassModel(modelbiped);
-                return true;
-            }
-        }
-        return false;
-    }
-
-    public void renderPlayer(EntityPlayer entity, double d, double d1, double d2,
-            float yaw, float partialTick)
-    {
-    	GL11.glEnable(GL11.GL_BLEND);
-    	GL11.glBlendFunc(GL11.GL_SRC_ALPHA, GL11.GL_ONE_MINUS_SRC_ALPHA);
-        mainModel = entity.slimModel ? modelSlim : modelThick;
-        modelBipedMain = entity.slimModel ? modelSlim : modelThick;
-    }
-
-    protected void renderName(EntityPlayer entity, double d, double d1, double d2)
-    {
-        if (Minecraft.getMinecraft(this).thePlayer.getGamemode() != Gamemode.spectator && entity.getGamemode() == Gamemode.spectator) {
-            return;
-        }
-        if(Minecraft.getMinecraft(this).gameSettings.immersiveMode.drawNames() && renderDispatcher.camera != null)
-        {
-            if (renderDispatcher.camera instanceof EntityCamera && ((EntityCamera)renderDispatcher.camera).entity == entity)
-            {
-                return;
-            }
-            float f = 1.6F;
-            float f1 = 0.01666667F * f;
-            float f2 = (float) renderDispatcher.camera.distanceTo(entity); //getting lost on renderManager.livingPlayer
-            float f3 = entity.isSneaking() ? 32F : 64F;
-            if(f2 < f3)
-            {
-                String s = entity.getDisplayName();
-                if(!entity.isSneaking())
-                {
-                    if(entity.isPlayerSleeping())
-                    {
-                        renderLivingLabel(entity, s, d, d1 - 1.5D, d2, 64, false);
-                    } else
-                    {
-                        renderLivingLabel(entity, s, d, d1, d2, 64, false);
-                    }
-                } else
-                {
-                    FontRenderer fontrenderer = getFontRenderer();
-                    GL11.glPushMatrix();
-                    GL11.glTranslatef((float)d + 0.0F, (float)d1 + 2.3F, (float)d2);
-                    GL11.glNormal3f(0.0F, 1.0F, 0.0F);
-                    GL11.glRotatef(-renderDispatcher.viewLerpYaw, 0.0F, 1.0F, 0.0F);
-                    GL11.glRotatef(renderDispatcher.viewLerpPitch, 1.0F, 0.0F, 0.0F);
-                    GL11.glScalef(-f1, -f1, f1);
-                    GL11.glDisable(2896 /*GL_LIGHTING*/);
-                    GL11.glTranslatef(0.0F, 0.25F / f1, 0.0F);
-                    GL11.glDepthMask(false);
-                    GL11.glEnable(3042 /*GL_BLEND*/);
-                    GL11.glBlendFunc(GL11.GL_SRC_ALPHA, GL11.GL_ONE_MINUS_SRC_ALPHA);
-                    Tessellator tessellator = Tessellator.instance;
-                    GL11.glDisable(3553 /*GL_TEXTURE_2D*/);
-                    tessellator.startDrawingQuads();
-                    int i = fontrenderer.getStringWidth(s) / 2;
-                    tessellator.setColorRGBA_F(0.0F, 0.0F, 0.0F, 0.25F);
-                    tessellator.addVertex(-i - 1, -1D, 0.0D);
-                    tessellator.addVertex(-i - 1, 8D, 0.0D);
-                    tessellator.addVertex(i + 1, 8D, 0.0D);
-                    tessellator.addVertex(i + 1, -1D, 0.0D);
-                    tessellator.draw();
-                    GL11.glEnable(3553 /*GL_TEXTURE_2D*/);
-                    GL11.glDepthMask(true);
-                    fontrenderer.drawString(s, -fontrenderer.getStringWidth(s) / 2, 0, 0x20ffffff);
-                    GL11.glEnable(2896 /*GL_LIGHTING*/);
-                    GL11.glDisable(3042 /*GL_BLEND*/);
-                    GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
-                    GL11.glPopMatrix();
-                }
-            }
-        }
-    }
-    protected void renderSpecials(EntityPlayer entity, float partialTick)
+    protected void renderSpecials(Player entity, float partialTick)
     {
         if (Minecraft.getMinecraft(this).thePlayer.getGamemode() == Gamemode.spectator && entity.getGamemode() == Gamemode.spectator){
             GL11.glColor4f(1f, 1f, 1f, 0.25f);
@@ -174,7 +48,7 @@ public class PlayerRenderer extends LivingRenderer<EntityPlayer>
         if(itemstack != null && itemstack.getItem().id < Block.blocksList.length)
         {
             GL11.glPushMatrix();
-            modelBipedMain.bipedHead.postRender(0.0625F);
+            modelBipedMain.head.translateTo(0.0625F);
             if(BlockModelDispatcher.getInstance().getDispatch(Block.blocksList[itemstack.itemID]).shouldItemRender3d())
             {
                 float f1 = 0.625F;
@@ -186,16 +60,17 @@ public class PlayerRenderer extends LivingRenderer<EntityPlayer>
             GL11.glPopMatrix();
         }
 
-        boolean renderCape = loadDownloadableTexture("https://api.betterthanadventure.net/capes?username=" + entity.username, null, null);
+        boolean renderCape = bindDownloadableTexture("https://api.betterthanadventure.net/capes?username=" + entity.username, null, null);
         if (!renderCape)
         {
-            renderCape = loadDownloadableTexture(entity.capeURL, null, null);
+            renderCape = bindDownloadableTexture(entity.capeURL, null, null);
         }
     	
     	if(renderCape) {
             GL11.glPushMatrix();
+            GL11.glColor4f(1f, 1f, 1f, 1f);
             GL11.glTranslatef(0.0F, 0.0F, 0.125F);
-            float yawOff = entity.prevRenderYawOffset + (entity.renderYawOffset - entity.prevRenderYawOffset) * partialTick;
+            float yawOff = entity.yBodyRotO + (entity.yBodyRot - entity.yBodyRotO) * partialTick;
             float bodyAngle = 5;
             if(entity.isSneaking())
             {
@@ -222,112 +97,198 @@ public class PlayerRenderer extends LivingRenderer<EntityPlayer>
 		ItemStack itemstack1 = entity.inventory.getCurrentItem();
 		if(itemstack1 != null) {
             GL11.glPushMatrix();
-            modelBipedMain.bipedRightArm.postRender(0.0625F);
+            modelBipedMain.arm0.translateTo(0.0625F);
             BlockModel.setRenderBlocks(renderDispatcher.itemRenderer.renderBlocksInstance);
             ItemModelDispatcher.getInstance().getDispatch(itemstack1).renderItemThirdPerson(Tessellator.instance, renderDispatcher.itemRenderer, entity, itemstack1, true);
             GL11.glPopMatrix();
 		}
 	}
-
-    protected void func_186_b(EntityPlayer entity, float f)
-    {
-        float f1 = 0.9375F;
-        GL11.glScalef(f1, f1, f1);
-    }
-
-    public void drawFirstPersonHand(EntityPlayer player, boolean isLeft)
+    public void drawFirstPersonHand(Player player, boolean isLeft)
     {
         mainModel = player.slimModel ? modelSlim : modelThick;
         modelBipedMain = player.slimModel ? modelSlim : modelThick;
 
         modelBipedMain.onGround = 0.0F;
         modelBipedMain.isRiding = false;
-        modelBipedMain.setRotationAngles(0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0625F);
+        modelBipedMain.setupAnimation(0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0625F);
         if (isLeft){
-            modelBipedMain.bipedLeftArm.render(0.0625F);
+            modelBipedMain.arm1.render(0.0625F);
         } else {
-            modelBipedMain.bipedRightArm.render(0.0625F);
+            modelBipedMain.arm0.render(0.0625F);
         }
-        if (modelBipedMain instanceof ModelPlayer)
+        if (modelBipedMain instanceof PlayerModel)
         {
             if (isLeft){
-                ((ModelPlayer)modelBipedMain).bipedLeftArmOverlay.render(0.0625F);
+                ((PlayerModel)modelBipedMain).bipedLeftArmOverlay.render(0.0625F);
             } else {
-                ((ModelPlayer)modelBipedMain).bipedRightArmOverlay.render(0.0625F);
+                ((PlayerModel)modelBipedMain).bipedRightArmOverlay.render(0.0625F);
             }
         }
     }
-
-    protected void func_22016_b(EntityPlayer entity, double d, double d1, double d2)
+    @Override
+    protected void renderSpecials(Tessellator tessellator, Player entity, double d, double d1, double d2)
     {
-        if(entity.isAlive() && entity.isPlayerSleeping())
-        {
-            super.translateModel(entity, d + (double)entity.field_22063_x, d1 + (double)entity.field_22062_y, d2 + (double)entity.field_22061_z);
-        } else
-        {
-            super.translateModel(entity, d, d1, d2);
+        if (Minecraft.getMinecraft(this).thePlayer.getGamemode() != Gamemode.spectator && entity.getGamemode() == Gamemode.spectator) {
+            return;
         }
-    }
-
-    protected void func_22017_a(EntityPlayer entity, float f, float f1, float f2)
-    {
-        if(entity.isAlive() && entity.isPlayerSleeping())
-        {
-            GL11.glRotatef(entity.getBedOrientationInDegrees(), 0.0F, 1.0F, 0.0F);
-            GL11.glRotatef(getDeathMaxRotation(entity), 0.0F, 0.0F, 1.0F);
-            GL11.glRotatef(270F, 0.0F, 1.0F, 0.0F);
-        } else
+        if(Minecraft.getMinecraft(this).gameSettings.immersiveMode.drawNames() && renderDispatcher.camera != null) // Render name
         {
-            super.rotateModel(entity, f, f1, f2);
+            if (renderDispatcher.camera instanceof EntityCamera && ((EntityCamera)renderDispatcher.camera).mob == entity)
+            {
+                return;
+            }
+            float f = 1.6F;
+            float f1 = 0.01666667F * f;
+            float f2 = (float) renderDispatcher.camera.distanceTo(entity); //getting lost on renderManager.livingPlayer
+            float f3 = entity.isSneaking() ? 32F : 64F;
+            if(f2 < f3)
+            {
+                String s = entity.getDisplayName();
+                if(!entity.isSneaking())
+                {
+                    if(entity.isPlayerSleeping())
+                    {
+                        renderLivingLabel(tessellator, entity, s, d, d1 - 1.5D, d2, 64, false);
+                    } else
+                    {
+                        renderLivingLabel(tessellator, entity, s, d, d1, d2, 64, false);
+                    }
+                } else
+                {
+                    FontRenderer fontrenderer = getFontRenderer();
+                    GL11.glPushMatrix();
+                    GL11.glTranslatef((float)d + 0.0F, (float)d1 + 2.3F, (float)d2);
+                    GL11.glNormal3f(0.0F, 1.0F, 0.0F);
+                    GL11.glRotatef(-renderDispatcher.viewLerpYaw, 0.0F, 1.0F, 0.0F);
+                    GL11.glRotatef(renderDispatcher.viewLerpPitch, 1.0F, 0.0F, 0.0F);
+                    GL11.glScalef(-f1, -f1, f1);
+                    GL11.glDisable(GL11.GL_LIGHTING);
+                    GL11.glTranslatef(0.0F, 0.25F / f1, 0.0F);
+                    GL11.glDepthMask(false);
+                    GL11.glEnable(GL11.GL_BLEND);
+                    GL11.glBlendFunc(GL11.GL_SRC_ALPHA, GL11.GL_ONE_MINUS_SRC_ALPHA);
+                    GL11.glDisable(GL11.GL_TEXTURE_2D);
+                    tessellator.startDrawingQuads();
+                    int i = fontrenderer.getStringWidth(s) / 2;
+                    tessellator.setColorRGBA_F(0.0F, 0.0F, 0.0F, 0.25F);
+                    tessellator.addVertex(-i - 1, -1D, 0.0D);
+                    tessellator.addVertex(-i - 1, 8D, 0.0D);
+                    tessellator.addVertex(i + 1, 8D, 0.0D);
+                    tessellator.addVertex(i + 1, -1D, 0.0D);
+                    tessellator.draw();
+                    GL11.glEnable(GL11.GL_TEXTURE_2D);
+                    GL11.glDepthMask(true);
+                    fontrenderer.drawString(s, -fontrenderer.getStringWidth(s) / 2, 0, 0x20ffffff);
+                    GL11.glEnable(GL11.GL_LIGHTING);
+                    GL11.glDisable(GL11.GL_BLEND);
+                    GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
+                    GL11.glPopMatrix();
+                }
+            }
         }
     }
 
     @Override
-    protected void passSpecialRender(EntityPlayer entity, double d, double d1, double d2)
-    {
-        renderName(entity, d, d1, d2);
-    }
-
-    @Override
-    protected void preRenderCallback(EntityPlayer entity, float f)
+    protected void setupScale(Player entity, float partialTick)
     {
         if (Minecraft.getMinecraft(this).thePlayer.getGamemode() == Gamemode.spectator && entity.getGamemode() == Gamemode.spectator){
             GL11.glColor4f(1f, 1f, 1f, 0.25f);
         } else if (entity.getGamemode() == Gamemode.spectator) {
             GL11.glColor4f(1f, 1f, 1f, 0.0f);
         }
-        func_186_b(entity, f);
+
+        float scale = 0.9375F;
+        GL11.glScalef(scale, scale, scale);
+
         if (entity.isDwarf()) {
             GL11.glScalef(0.6f, 0.5f, 0.6f);
         }
     }
 
     @Override
-    protected boolean shouldRenderPass(EntityPlayer entity, int renderPass, float partialTick)
-    {
-        return setArmorModel(entity, renderPass, partialTick);
+    protected boolean prepareArmor(Player entity, int layer, float partialTick) {
+        ItemStack itemstack = entity.inventory.armorItemInSlot(3 - layer);
+        if(itemstack != null)
+        {
+            Item item = itemstack.getItem();
+            if(item instanceof QuiverItem)
+            {
+                bindTexture("/assets/minecraft/textures/armor/quiver.png");
+                BipedModel bipedModel = modelArmorChestplate;
+                bipedModel.body.visible = layer == 1 || layer == 2;
+                setArmorModel(bipedModel);
+                return true;
+            }
+            if(item instanceof EndlessQuiverItem)
+            {
+                bindTexture("/assets/minecraft/textures/armor/quiver_golden.png");
+                BipedModel bipedModel = modelArmorChestplate;
+                bipedModel.body.visible = layer == 1 || layer == 2;
+                setArmorModel(bipedModel);
+                return true;
+            }
+            if(item == Items.ARMOR_BOOTS_ICESKATES)
+            {
+                bindTexture("/assets/minecraft/textures/armor/skates.png");
+                BipedModel bipedModel = modelArmorChestplate;
+                bipedModel.leg0.visible = layer == 2 || layer == 3;
+                bipedModel.leg1.visible = layer == 2 || layer == 3;
+                setArmorModel(bipedModel);
+                return true;
+            }
+            if(item instanceof IArmorItem && ((IArmorItem) item).getArmorMaterial() != null)
+            {
+                IArmorItem armorItem = (IArmorItem)item;
+                bindTexture(String.format("/assets/%s/textures/armor/%s_%d.png", armorItem.getArmorMaterial().identifier.namespace, armorItem.getArmorMaterial().identifier.value, (layer != 2 ? 1 : 2)));
+                BipedModel bipedModel = layer != 2 ? modelArmorChestplate : modelArmor;
+                bipedModel.head.visible = layer == 0;
+                bipedModel.hair.visible = layer == 0;
+                bipedModel.body.visible = layer == 1 || layer == 2;
+                bipedModel.arm0.visible = layer == 1;
+                bipedModel.arm1.visible = layer == 1;
+                bipedModel.leg0.visible = layer == 2 || layer == 3;
+                bipedModel.leg1.visible = layer == 2 || layer == 3;
+                setArmorModel(bipedModel);
+                return true;
+            }
+        }
+        return false;
     }
 
     @Override
-    protected void renderEquippedItems(EntityPlayer entity, float partialTick)
+    protected void renderAdditional(Player entity, float partialTick)
     {
         renderSpecials(entity, partialTick);
     }
 
     @Override
-    protected void rotateModel(EntityPlayer entity, float ticksExisted, float headYawOffset, float partialTick)
+    protected void setupRotations(Player entity, float ticksExisted, float bodyYaw, float partialTick)
     {
-        func_22017_a(entity, ticksExisted, headYawOffset, partialTick);
+        if(entity.isAlive() && entity.isPlayerSleeping())
+        {
+            GL11.glRotatef(entity.getBedOrientationInDegrees(), 0.0F, 1.0F, 0.0F);
+            GL11.glRotatef(getMaxDeathRotation(entity), 0.0F, 0.0F, 1.0F);
+            GL11.glRotatef(270F, 0.0F, 1.0F, 0.0F);
+        } else
+        {
+            super.setupRotations(entity, ticksExisted, bodyYaw, partialTick);
+        }
     }
 
     @Override
-    protected void translateModel(EntityPlayer entity, double x, double y, double z)
+    protected void translateModel(Player entity, double x, double y, double z)
     {
-        func_22016_b(entity, x, y, z);
+        if(entity.isAlive() && entity.isPlayerSleeping())
+        {
+            super.translateModel(entity, x + (double)entity.sleepOffX, y + (double)entity.sleepOffY, z + (double)entity.sleepOffZ);
+        } else
+        {
+            super.translateModel(entity, x, y, z);
+        }
     }
 
     @Override
-    public void render(EntityPlayer entity, double x, double y, double z,
+    public void render(Tessellator tessellator, Player entity, double x, double y, double z,
                        float yaw, float partialTick)
     {
         GL11.glEnable(GL11.GL_BLEND);
@@ -336,30 +297,22 @@ public class PlayerRenderer extends LivingRenderer<EntityPlayer>
         modelBipedMain = entity.slimModel ? modelSlim : modelThick;
 
         ItemStack itemstack = entity.inventory.getCurrentItem();
-        modelArmorChestplate.field_1278_i = modelArmor.field_1278_i = modelBipedMain.field_1278_i = itemstack != null;
-        modelArmorChestplate.isSneak = modelArmor.isSneak = modelBipedMain.isSneak = entity.isSneaking();
+        modelArmorChestplate.holdingRightHand = modelArmor.holdingRightHand = modelBipedMain.holdingRightHand = itemstack != null;
+        modelArmorChestplate.sneaking = modelArmor.sneaking = modelBipedMain.sneaking = entity.isSneaking();
         modelArmorChestplate.isRiding = modelArmor.isRiding = modelBipedMain.isRiding = entity.isPassenger();
         double d3 = y - (double)entity.heightOffset;
-        if(entity.isSneaking() && !(entity instanceof EntityPlayerSP))
+        if(entity.isSneaking() && !(entity instanceof LocalPlayer))
         {
             d3 -= 0.125D;
         }
-        super.render(entity, x, d3, z, yaw, partialTick);
-        modelArmorChestplate.isSneak = modelArmor.isSneak = modelBipedMain.isSneak = false;
-        modelArmorChestplate.field_1278_i = modelArmor.field_1278_i = modelBipedMain.field_1278_i = false;
+        super.render(tessellator, entity, x, d3, z, yaw, partialTick);
+        modelArmorChestplate.sneaking = modelArmor.sneaking = modelBipedMain.sneaking = false;
+        modelArmorChestplate.holdingRightHand = modelArmor.holdingRightHand = modelBipedMain.holdingRightHand = false;
         GL11.glDisable(GL11.GL_BLEND);
     }
 
     @Override
-    public void loadEntityTexture(EntityPlayer entity)
-    {
-        loadDownloadableTexture(entity.skinURL, entity.getEntityTexture(), PlayerSkinParser.instance);
+    public void loadEntityTexture(Player entity) {
+        bindDownloadableTexture(entity.skinURL, entity.getEntityTexture(), PlayerSkinParser.instance);
     }
-
-    private ModelBiped modelBipedMain;
-    private final ModelPlayer modelThick;
-    private final ModelPlayer modelSlim;
-    private final ModelBiped modelArmorChestplate;
-    private final ModelBiped modelArmor;
-    private final ModelSign modelSign;
 }
